package smartresource.core;

import java.util.*;

public class VariablesBindingManager{ 
	Vector bindings; //of HashMaps

	Vector newBindings; //of HashMaps

	final public static int TRUE_IF=0;
	final public static int FALSE_IF=1;

	public VariablesBindingManager(){
		bindings=new Vector();
		newBindings=new Vector();
	}

	//returns the number of matching bindings
	public int getNumberOfBindings(){
		return bindings.size();
	}

	//returns Nth of matching bindings
	public HashMap getBinding(int index){
		if(index>-1 && index<bindings.size()) 
			return (HashMap)bindings.elementAt(index);
		else return new HashMap();
	}


	//empty bindings created during the last 'evaluate' operation
	public void emptyNewBindings(){
		newBindings=new Vector();
	}

	//adopt, i.e. put as current, bindings created during the last 'evaluate' operation
	public void adoptNewBindings(){
		bindings=newBindings;
		emptyNewBindings();
	}
	

	public boolean evaluate(SemanticStatement st1, Vector v, int mode){

		boolean any=false;
		boolean all=false;

		if(bindings.size()==0){
		    	Iterator it=v.iterator();
		    	while(it.hasNext()){
				SemanticStatement st2=(SemanticStatement)it.next();
			        if(st1.equals(st2)){
				        if(!st1.hasVariables()){
						any=true;
						all=true;
					}
					else{
						HashMap new_binding=new HashMap();
						boolean ok=true;
						String var=st1.getSubjectVariableName();
						if(var!=null) new_binding.put(var,st2.subject);
						var=st1.getPredicateVariableName();
						if(var!=null){
							Object old=new_binding.put(var,st2.predicate);
							if(old!=null && !((String)old).equals(st2.predicate))
								ok=false;
						}
						var=st1.getObjectVariableName();
						if(var!=null){
							Object old=new_binding.put(var,st2.object);
							if(old!=null && !((String)old).equals(st2.object))
								ok=false;
						}
						if(ok){
							newBindings.add(new_binding);
							any=true;
							all=true;
						}
					}
				}

			}
			if(mode==FALSE_IF) newBindings.clear();

		}//no bindings

		else{
			all=true;
			Iterator it=bindings.iterator();
			while(it.hasNext()){
				HashMap binding=(HashMap)it.next();
		    		boolean match=false; //can match st1 with anything in v?
		    		Vector newSubBindings=new Vector();

				SemanticStatement st1_copy=new SemanticStatement(st1);
				st1_copy.bindVars(binding);
			    	
			    	Iterator it1=v.iterator();
			    	while(it1.hasNext()){
					SemanticStatement st2=(SemanticStatement)it1.next();
					if(st1_copy.equals(st2)){
						boolean ok=true;
						HashMap new_binding=new HashMap(binding);
						if(st1_copy.hasVariables()){
							String var=st1_copy.getSubjectVariableName();
							if(var!=null){
								Object old=new_binding.put(var,st2.subject);
								if(old!=null && !((String)old).equals(st2.subject))
									ok=false;
							}
							var=st1_copy.getPredicateVariableName();
							if(var!=null){
								Object old=new_binding.put(var,st2.predicate);
								if(old!=null && !((String)old).equals(st2.predicate))
									ok=false;
							}
							var=st1_copy.getObjectVariableName();
							if(var!=null){
								Object old=new_binding.put(var,st2.object);
								if(old!=null && !((String)old).equals(st2.object))
									ok=false;
							}
						}
						if(ok){
							newSubBindings.add(new_binding);
							any=true;
							match=true;
						}

					}//equals
					

				}//vector cycle
				
				if(mode==TRUE_IF){
					newBindings.addAll(newSubBindings);
				}
				if(mode==FALSE_IF){
					if(!match){
						all=false;
						HashMap new_binding=new HashMap(binding);
						newBindings.add(new_binding);
					}
				}

			}//binding cycle
		}//there are bindings

		if(mode==TRUE_IF) return any;
		else return all;

	}
	
}
