package smartresource.shared;

import smartresource.core.*;

import java.io.*;
import java.util.*;

import jade.core.behaviours.OneShotBehaviour;

public class SimpleSelectBehavior extends ReusableAtomicBehavior{

	public void action() {

		Vector inputs=getParameterValues("input");		
		((String)inputs.elementAt(0)).length(); //to cause exception if not given

		String output=getParameterValue("output");		
		output.equals(""); //to cause exception if null

		String criterion=getParameterValue("criterion");		
		criterion.equals(""); //to cause exception if null

		String evaluate=getParameterValue("evaluate");		

		VariablesBindingManager manager=new VariablesBindingManager();
		
		for(int i=0;i<inputs.size();i++){
			SemanticStatement st=new SemanticStatement((String)inputs.elementAt(i));
				
			boolean found=manager.evaluate(st, ((SmartResourceAgent)myAgent).beliefs, VariablesBindingManager.TRUE_IF);

			if(found){
				manager.adoptNewBindings();
			}
			else{
				success=false;
				return;
			}
		}

		HashMap vars=null;
	        int n=manager.getNumberOfBindings();
		if(n==1){
			vars=manager.getBinding(0);
			criterion="the only available";
		}
		else if(criterion.equals("random")){
			Random r=new Random();
			int rand=r.nextInt(n);
			vars=manager.getBinding(rand);
		}
		else if(criterion.equals("minimum") || criterion.equals("maximum")){
			evaluate.equals(""); //to cause exception if null

			Stack v[]=new Stack[n];
		        for(int i=0;i<n;i++) v[i]=new Stack();

			StringTokenizer token=new StringTokenizer(evaluate," ");
			while (token.hasMoreTokens()){
				String t=token.nextToken();
			        for(int i=0;i<n;i++){
			                HashMap binding=manager.getBinding(i);
			                if(t.equals("+")){
			                	double ar1=new Double((String)v[i].pop()).doubleValue();
			                	double ar2=new Double((String)v[i].pop()).doubleValue();
			                	double res=ar1+ar2;
			                	v[i].push(new Double(res).toString());
			                }
			                else if(t.equals("-")){
			                	double ar1=new Double((String)v[i].pop()).doubleValue();
			                	double ar2=new Double((String)v[i].pop()).doubleValue();
			                	double res=ar2-ar1;
			                	v[i].push(new Double(res).toString());
			                }
			                else if(t.equals("*")){
			                	double ar1=new Double((String)v[i].pop()).doubleValue();
			                	double ar2=new Double((String)v[i].pop()).doubleValue();
			                	double res=ar1*ar2;
			                	v[i].push(new Double(res).toString());
			                }
			                else if(t.equals("/")){
			                	double ar1=new Double((String)v[i].pop()).doubleValue();
			                	double ar2=new Double((String)v[i].pop()).doubleValue();
			                	double res=ar2/ar1;
			                	v[i].push(new Double(res).toString());
			                }
			                else if(t.startsWith("*")){
			                	String var=t.substring(1,t.length()-1);
			                	v[i].push(binding.get(var));
			                }
					else v[i].push(t);
			        }
			}
			if(criterion.equals("minimum")){
				double min=Double.MAX_VALUE;
				String minstr="";
				int best=-1;
			        for(int i=0;i<n;i++){
			        	String result=(String)v[i].pop();
			        	try{
				        	double res=new Double(result).doubleValue();
				        	if(res<min){ min=res; best=i;}
				        }
				        catch(NumberFormatException ex){
				        	if(min==Double.MAX_VALUE){
					        	if(minstr.equals("") || minstr.compareTo(result)>0){
					        		minstr=result;
					        		best=i;
					        	}
					        }
				        }
			        }
				vars=manager.getBinding(best);
			}
			else if(criterion.equals("maximum")){
				double max=Double.MIN_VALUE;
				String maxstr="";
				int best=-1;
			        for(int i=0;i<n;i++){
			        	String result=(String)v[i].pop();
			        	try{
				        	double res=new Double(result).doubleValue();
				        	if(res>max){ max=res; best=i;}
				        }
				        catch(NumberFormatException ex){
				        	if(max==Double.MIN_VALUE){
					        	if(maxstr.equals("") || maxstr.compareTo(result)<0){
					        		maxstr=result;
					        		best=i;
					        	}
					        }
				        }
			        }
				vars=manager.getBinding(best);
			}
		}		

		String v="";
		Iterator itvars=vars.entrySet().iterator();
		while(itvars.hasNext()){
			Map.Entry ent=(Map.Entry)itvars.next();
			String regex="\\*"+(String)ent.getKey()+"\\*";
			output=output.replaceAll(regex,(String)ent.getValue());
			v=v+"*"+(String)ent.getKey()+"*="+(String)ent.getValue()+" ";
		}

		SemanticStatement ss_output=new SemanticStatement(output);
		addBelief(ss_output);

		String pr=v+"is selected as "+criterion;
		if(criterion.equals("minimum") || criterion.equals("maximum"))
			pr=pr+" of ("+evaluate+")";
		print(pr);

	}
}
