package smartresource.shared;

import smartresource.core.*;

import java.io.*;
import java.util.*;
import java.util.zip.*;

public class UnzipperBehavior extends ReusableAtomicBehavior{

	public void action() {
		String filename=getParameterValue("input");
		filename.equals(""); //to cause exception if null

		String delete=getParameterValue("delete");
		if(delete==null) delete="false";

		File file=new File(filename);
    		String path=file.getParent();

		try {
	    		ZipFile zipFile=new ZipFile(file);
			Enumeration entries = zipFile.entries();
                        while(entries.hasMoreElements()){
                        	ZipEntry entry = (ZipEntry)entries.nextElement();
		        	if(!entry.isDirectory()){
		        	        File f=new File(entry.getName());
		        	        File p=f.getParentFile();
		        	        if(p!=null && !p.exists()) p.mkdirs();
	          		        
	          		        InputStream in=zipFile.getInputStream(entry);
					OutputStream out=new BufferedOutputStream(new FileOutputStream(path+"/"+entry.getName()));
					byte[] buffer = new byte[1024];
				        int len;
					while((len=in.read(buffer))>=0)
					      out.write(buffer, 0, len);

					in.close();
					out.close();
				}
			}
                        zipFile.close();
                        
                        print(filename+" unzipped");

                        if(delete.equals("true")){
				FileOutputStream fo=new FileOutputStream(file);
				fo.write(13);fo.write(10);
				fo.close();
				file.delete();
			}
    		
    		}catch (IOException ex){
			ex.printStackTrace();
			success=false;
	        }

	}
}
